#include <stdio.h>
#include <stdlib.h>
int n,q;

int x(int d[],int p[],int m)
{
    int s=0,v=0,a=p[0];
        for(int i=d[0]-1;i<m-1;i++)
    {
            if(a>0)
        {
            a--;
            s++;
        }
        else{
        if(v<n-1)
        {
            v++;
            a=p[v];
        }
        }
    }
    return s;
}
int main()
{
    scanf("%d",&n);
    scanf("%d",&q);
    int d[n],p[n],k[q];
    for(int i=0;i<n;i++)
    {
        scanf("%d",&d[i]);
        scanf("%d",&p[i]);
    }
    for(int i=0;i<q;i++)
        scanf("%d",&k[i]);
    for(int i=0;i<q;i++)
        printf("%d",x(d,p,k[i]));
    return 0;
}